/*
modstat.h
Copyright (C)2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

#ifndef _BHMODSTAT_
#define _BHMODSTAT_

#include <list>
#include <gtkmm/window.h>
#include <gdk/gdkkeysyms.h>
 
namespace BhPos{

/**
 * @defgroup bhmodstat Mode Status 
 * @{
 *
 * \ingroup mflib
 * @{
 */

#define KEY_ENABLED_BASE          0x00000001
#define KEY_ENABLED_ESCAPE       (KEY_ENABLED_BASE)
#define KEY_ENABLED_RETURN       (KEY_ENABLED_BASE << 1)
#define KEY_ENABLED_NUMERIC      (KEY_ENABLED_BASE << 2)
#define KEY_ENABLED_ALPHA        (KEY_ENABLED_BASE << 3)
#define KEY_ENABLED_FUNCTION     (KEY_ENABLED_BASE << 4)
#define KEY_ENABLED_NAVIGATION   (KEY_ENABLED_BASE << 5)
#define KEY_ENABLED_EDITING      (KEY_ENABLED_BASE << 6)
#define KEY_ENABLED_MAPPED       (KEY_ENABLED_BASE << 7)
#define KEY_ENABLED_PAYMENT      (KEY_ENABLED_BASE << 8)
#define KEY_ENABLED_NUMSYM       (KEY_ENABLED_BASE << 9)
#define KEY_ENABLED_PRINT        (KEY_ENABLED_BASE << 10)
#define KEY_ENABLED_MISC         (KEY_ENABLED_BASE << 11)
#define KEY_ENABLED_TRANS        (KEY_ENABLED_BASE << 12)
#define KEY_ENABLED_MICR         (KEY_ENABLED_BASE << 13)
#define KEY_ENABLED_OPERATOR     (KEY_ENABLED_BASE << 14)
#define KEY_ENABLED_DELETE       (KEY_ENABLED_BASE << 15)
#define KEY_ENABLED_REMOVE       (KEY_ENABLED_BASE << 16)
#define KEY_ENABLED_PAYTYPE      (KEY_ENABLED_BASE << 17)
#define KEY_ENABLED_PRESALE      (KEY_ENABLED_BASE << 18)
#define KEY_ENABLED_SWAP         (KEY_ENABLED_BASE << 19)
#define KEY_ENABLED_CTRL         (KEY_ENABLED_BASE << 20)
#define KEY_ENABLED_SHIFT        (KEY_ENABLED_BASE << 21)
#define KEY_ENABLED_ALT          (KEY_ENABLED_BASE << 22)

#define KEY_ENABLE_GROUP_IDLE         (KEY_ENABLED_NUMERIC | KEY_ENABLED_ESCAPE | \
                                       KEY_ENABLED_MISC | KEY_ENABLED_TRANS | \
                                       KEY_ENABLED_MAPPED | KEY_ENABLED_RETURN | PK_SALETYPE | \
                                       PK_PLULOOKUP | PK_CASH)
                                 
#define KEY_ENABLE_GROUP_TRANSID      (KEY_ENABLED_NUMERIC | KEY_ENABLED_ESCAPE | \
                                       KEY_ENABLED_MISC | KEY_ENABLED_TRANS | KEY_ENABLED_RETURN)
                                      
#define KEY_ENABLE_GROUP_QUANTITY     (KEY_ENABLED_NUMERIC | KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN)
                                    
#define KEY_ENABLE_GROUP_SALE         (KEY_ENABLED_NUMERIC | KEY_ENABLED_ESCAPE | \
                                       KEY_ENABLED_RETURN | KEY_ENABLED_NAVIGATION | \
                                       KEY_ENABLED_MAPPED | KEY_ENABLED_ALPHA | \
                                       KEY_ENABLED_MISC | KEY_ENABLED_EDITING | KEY_ENABLED_REMOVE | \
                                       KEY_ENABLED_SWAP)

#define KEY_ENABLE_GROUP_ITEMADD      (KEY_ENABLED_NUMERIC | KEY_ENABLED_ESCAPE | \
                                       KEY_ENABLED_RETURN | KEY_ENABLED_MISC | KEY_ENABLED_EDITING )                                   
                                    
#define KEY_ENABLE_GROUP_TOTAL        (KEY_ENABLED_ESCAPE | KEY_ENABLED_PAYMENT)
                                                                        
#define KEY_ENABLE_GROUP_TENDER       (KEY_ENABLED_NUMERIC | KEY_ENABLED_ESCAPE | \
                                       KEY_ENABLED_RETURN | KEY_ENABLED_PAYMENT | \
                                       KEY_ENABLED_EDITING)
                                       
#define KEY_ENABLE_GROUP_REMOVE       (KEY_ENABLED_NUMERIC | KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN)                                       
                                    
#define KEY_ENABLE_GROUP_PAYMENT       KEY_ENABLED_ESCAPE

#define KEY_ENABLE_GROUP_INEDIT       (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_EDITING | \
                                       KEY_ENABLED_NAVIGATION | KEY_ENABLED_OPERATOR | KEY_ENABLED_DELETE)
                                    
#define KEY_ENABLE_GROUP_TENDEREDIT   (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_EDITING | \
                                       KEY_ENABLED_NAVIGATION | KEY_ENABLED_DELETE)

#define KEY_ENABLE_GROUP_GENACK       (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN)

#define KEY_ENABLE_GROUP_CASHADJUST   (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_OPERATOR | \
                                       KEY_ENABLED_NAVIGATION | KEY_ENABLED_NUMERIC | KEY_ENABLED_EDITING)
                                       
#define KEY_ENABLE_GROUP_CASHADJUSTOP (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NUMERIC)

#define KEY_ENABLE_GROUP_CUSTOMERSUMM (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NAVIGATION)

#define KEY_ENABLE_GROUP_CUSTTRANS    (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NAVIGATION)

#define KEY_ENABLE_GROUP_EPHEMADD     (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NAVIGATION | \
                                       KEY_ENABLED_NUMERIC)
                                       
#define KEY_ENABLE_GROUP_OPENBALANCE  (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NUMERIC | \
                                       KEY_ENABLED_NAVIGATION)
                                       
#define KEY_ENABLE_GROUP_BLINDBALANCE (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NUMERIC | \
                                       KEY_ENABLED_EDITING)
                                       
#define KEY_ENABLE_GROUP_RETURNREASON (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NAVIGATION)

#define KEY_ENABLE_GROUP_PRICELIST    (KEY_ENABLED_ESCAPE | KEY_ENABLED_RETURN | KEY_ENABLED_NAVIGATION)

#define PK_QUANTITY   GDK_F1   // or weigh
#define PK_REQUEST    GDK_F2
#define PK_SALETYPE   GDK_F3
#define PK_ABSWAP     GDK_F4

#define PK_CASH       GDK_F5
#define PK_CREDIT     GDK_F6
#define PK_CHEQUE     GDK_F7
#define PK_CHARGE     GDK_F8

#define PK_OTHER      GDK_F9
#define PK_RETURNS    GDK_F10  // or return item in sale
#define PK_PLULOOKUP  GDK_F11
#define PK_REMOVE     GDK_F12

#define PK_PRINT      GDK_F13

// less used payment keys - remap as desired.
#define PK_CREDITRETURN    666
#define PK_CREDITSLIP      667
#define PK_GIFTVOUCHER     668
#define PK_TPVOUCHER       669
#define PK_INTCOUPON       670
#define PK_TPCOUPON        671
#define PK_LUNCHSTAMP      672
#define PK_INHOUSECHARGE   673
#define PK_STORECARD       674
#define PK_CREDIT_CB       676
#define PK_CHEQUE_CB       677
#define PK_SMARTC_CB       678
#define PK_TOKEN_CB        679
#define PK_VOUCHER_CB      680
#define PK_COUPON_CB       681
#define PK_OTHER_CB        682

// keys with Ctrl
#define PK_DEF_RENTALLIST     GDK_A
#define PK_DEF_BLINDBALANCE   GDK_B
#define PK_DEF_CUSTOMERLOOKUP GDK_C
#define PK_DEF_DELIVERY       GDK_D
#define PK_DEF_EPHEMERALIN    GDK_E
#define PK_DEF_TABLETCAPTURE  GDK_F
#define PK_DEF_GOODSIN        GDK_G
#define PK_DEF_REPEATITEM     GDK_I
#define PK_DEF_CASHADJUST     GDK_J
#define PK_DEF_LAYBY          GDK_L
#define PK_DEF_TRANSMOVE      GDK_M
#define PK_DEF_NOSALE         GDK_N
#define PK_DEF_OPENBAL        GDK_O
#define PK_DEF_RENTAL         GDK_R
#define PK_DEF_TRANSSTORE     GDK_S
#define PK_DEF_TRANSSUMMARY   GDK_T
#define PK_DEF_USERSUMMARY    GDK_U
#define PK_DEF_DELIVERYPAY    GDK_V
#define PK_DEF_DELIVERYLIST   GDK_Y
#define PK_DEF_00             GDK_Z

// keys with Shift
#define PK_SDEF_CLOCKIN    	   GDK_F1
#define PK_SDEF_CLOCKOUT    	   GDK_F2
#define PK_SDEF_PAYIN      	   GDK_F3
#define PK_SDEF_PAYOUT     	   GDK_F4
#define PK_SDEF_DISCOUNT     	   GDK_F5
#define PK_SDEF_CASHBACK_CREDIT  GDK_F6
#define PK_SDEF_CASHBACK_CHEQUE  GDK_F7
#define PK_SDEF_CASHBACK_COUPON  GDK_F8
#define PK_SDEF_CASHBACK_OTHER   GDK_F9
#define PK_SDEF_RETURNSMODE      GDK_F10
#define PK_SDEF_ZTAPE            GDK_Z

#define PK_NUMSEP    GDK_comma
#define PK_NUMDEC    GDK_period

enum BhClientStatus{
   BHCLIENT_STATUS_NONE=0,
   BHCLIENT_STATUS_LOGGEDOUT,
   BHCLIENT_STATUS_USERLOOKUP,
   BHCLIENT_STATUS_IDLE,
   BHCLIENT_STATUS_ITEMADD,
   BHCLIENT_STATUS_TRANSID,
   BHCLIENT_STATUS_ITEMLOOKUP,
   BHCLIENT_STATUS_SALE,
   BHCLIENT_STATUS_QUANTITY,
   BHCLIENT_STATUS_INEDIT,
   BHCLIENT_STATUS_ITEMDESC,
   BHCLIENT_STATUS_ITEMPRICE,
   BHCLIENT_STATUS_PLULOOKUP,
   BHCLIENT_STATUS_ITEMLOOKUPDN,
   BHCLIENT_STATUS_CASHITEM,
   BHCLIENT_STATUS_TOTAL,
   BHCLIENT_STATUS_TENDERTYPE,
   BHCLIENT_STATUS_TENDERAMOUNT,
   
   BHCLIENT_STATUS_DRAWEROPEN,
   BHCLIENT_STATUS_ITEMFLAGACK,
   BHCLIENT_STATUS_PAYAUTH,
   BHCLIENT_STATUS_WAITSWIPE,
   BHCLIENT_STATUS_WAITMICR,
   BHCLIENT_STATUS_WAITCHPRINT,
   BHCLIENT_STATUS_WAITCASHD,
   BHCLIENT_STATUS_COMMIT,
   BHCLIENT_STATUS_CASHADJUST,
   BHCLIENT_STATUS_CASHADJUSTADD,
   BHCLIENT_STATUS_CASHADJUSTSUB,
   BHCLIENT_STATUS_CASHADJUSTABS,
   BHCLIENT_STATUS_RETURNSADD,
   BHCLIENT_STATUS_RETURNSSUB,
   BHCLIENT_STATUS_RETURNSABS,
   BHCLIENT_STATUS_TRANSRETREIVE,
   BHCLIENT_STATUS_RETCOMMIT,
   BHCLIENT_STATUS_WAITONTAXLIST,
   BHCLIENT_STATUS_WAITONPRICELIST,
   BHCLIENT_STATUS_SERVERACK,
   BHCLIENT_STATUS_LOGOUTACK,
   BHCLIENT_STATUS_QUITACK,
   BHCLIENT_STATUS_CANCELTRANS,
   BHCLIENT_STATUS_TENDEREDIT,
   BHCLIENT_STATUS_DISCOUNT,
   BHCLIENT_STATUS_REMOVE,
   BHCLIENT_STATUS_CASHDCOMMIT,
   BHCLIENT_STATUS_WAITONSCALES,
   BHCLIENT_STATUS_DELIVERYDONE,
   BHCLIENT_STATUS_EPHEMCOMMIT,
   BHCLIENT_STATUS_EPHEMLOOKUP,
   BHCLIENT_STATUS_QUANTITYEDIT,
   BHCLIENT_STATUS_AMOUNTEDIT,
   BHCLIENT_STATUS_TRANSIDENTRY,
   BHCLIENT_STATUS_CASHBACKCHECK,
   BHCLIENT_STATUS_MICRCOMMIT,
   BHCLIENT_STATUS_WAITCHINSERT,
   BHCLIENT_STATUS_PAYIN,
   BHCLIENT_STATUS_PAYOUT,
   BHCLIENT_STATUS_ZTAPE,
   BHCLIENT_STATUS_RETURNREASON
};

enum BhClientMode{
   BHCLIENT_MODE_UNKNOWN=0,
   BHCLIENT_MODE_TRANSACTION,
   BHCLIENT_MODE_SUMMARY,
   BHCLIENT_MODE_USERSUMMARY,
   BHCLIENT_MODE_CASHADJUST,
   BHCLIENT_MODE_RETURNS,
   BHCLIENT_MODE_GOODSIN,
   BHCLIENT_MODE_RETURNSPASS,
   BHCLIENT_MODE_TRANSEDIT,
   BHCLIENT_MODE_CUSTLIST,
   BHCLIENT_MODE_LAYBYLIST,
   BHCLIENT_MODE_RENTALLIST,
   BHCLIENT_MODE_DELIVERYLIST,
   BHCLIENT_MODE_BLINDBALANCE,
   BHCLIENT_MODE_EPHEMERAL,
   BHCLIENT_MODE_CUSTTRANSTENDER,
   BHCLIENT_MODE_CUSTPAYCOMMIT,
   BHCLIENT_MODE_OPENBAL,
   BHCLIENT_MODE_RETURNREASON,
   BHCLIENT_MODE_TRANSSELECT,
   BHCLIENT_MODE_PRICESELECT
};

enum BhModStatParam{
   BHMODSTAT_MODE,
   BHMODSTAT_STATUS,
   BHMODSTAT_KEYGROUP
};

/*! \brief A class to handle mode/ status. */
class CModeStatus
{
   BhClientMode   mode;
   BhClientStatus status;
   unsigned int keygrp;

public:
   CModeStatus();
   /*! CModeStatus
		\param m mode
		\param s status
      \param k keygroup
	*/
   CModeStatus(BhClientMode m, BhClientStatus s, unsigned int k);
   ~CModeStatus();
   CModeStatus& operator=(const CModeStatus&);
   CModeStatus* operator&();
   bool operator==(CModeStatus const&);
   bool operator!=(CModeStatus const&);
   /*! KeyEnabled
		\param kg keygroup
		\return true if key is enabled, false otherwise.
	*/
   bool KeyEnabled(unsigned int kg);
   /*! Set
      \enum BhModStatParam p
		\param v value
	*/
   void Set(BhModStatParam p, void *v);
   void Set(BhClientMode m, BhClientStatus s, unsigned int k);
   /*! Get
      \enum BhModStatParam p
		\return value
	*/
   int Get(BhModStatParam p, void *v);
};

/*! \brief A class to handle lists of mode/states.*/
class CModeStatusList
{
	std::list<CModeStatus> entry;
	
public:	
	CModeStatusList();
	~CModeStatusList();
   CModeStatusList& operator=(const CModeStatusList&);
   CModeStatusList* operator&();
   bool operator==(CModeStatusList const&);
   bool operator!=(CModeStatusList const&);
   void Clear();
	int  Push(const CModeStatus&);
   bool Pop();
	bool Pop(BhClientMode *, BhClientStatus *, unsigned int *);
	bool Current(BhClientMode *, BhClientStatus *, unsigned int *);
   bool KeyEnabled(GdkEventKey *event);
};

/* @}
	@} */
}

#endif
