/*
   buttontable.h
   Copyright (C)2004  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
#ifndef BUTTONTABLE_H
#define BUTTONTABLE_H

#include <vector>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include <gtkmm/main.h>
#include <gtkmm/table.h>

#include "bhsmartbutton.h"

namespace bhpos{

/**
 * @defgroup bhwidget Widgets
 * @{
 *
 * @ingroup commlib
 * @{	
 */
   
namespace widget{

/*
 * @defgroup smartbutton A not very smart button
 * @{
 *
 * @ingroup bhwidget
 * @{	
 */

class ButtonTable : public Gtk::Table
{
private:
   int x; 
   int y;
   int padding;
   std::vector<SmartButton> buttons;

protected:
   //typedef std::vector<Gtk::Justification> tjustification;
   //tjustification justification;
   //guint          NextRow;

public:
   ButtonTable();
   ButtonTable(int xs, int ys, int p);
   ~ButtonTable();
   int ParseConfig(char *fn);
   void Set(int x, int y, SmartButton& button);

   //void set_column_justification(guint col, Gtk::Justification justification);  
   //void add_row(Gtk::Widget& widgetA, Gtk::Widget& widgetB);
   //void add_row(const Glib::ustring& strText, Gtk::Widget& widgetB);
   //void add_row(Gtk::Widget& widgetA); //Span 2 columns.
};

/* }@ 
	}@ */

}

/* }@ 
	}@ */

namespace parser{

/* }@
 *
 * @ingroup buttontable
 * @{
 */
	
#define BTP_PARAM_NAME             1
#define BTP_PARAM_MANU             2
#define BTP_PARAM_MODEL            3
#define BTP_PARAM_IF               4
#define BTP_PARAM_LICENCE          5
#define BTP_PARAM_COPYRIGHT        6
#define BTP_PARAM_CREATEWHO        7
#define BTP_PARAM_CREATEWHEN       8
#define BTP_PARAM_CREATEWHENSTRING 9
#define BTP_PARAM_MODWHO           10
#define BTP_PARAM_MODWHEN          11
#define BTP_PARAM_MODWHENSTRING    12
#define BTP_PARAM_PROGKEYS         13
#define BTP_PARAM_TS               14 
#define BTP_PARAM_TSX              15
#define BTP_PARAM_TSY              16
#define BTP_PARAM_TSXRES           17
#define BTP_PARAM_TSYRES           18

/* }@
 *
 * @ingroup buttontable
 * @{
 */
 
class ButtonTableParser
{
private:
   char     *filename;
   bool      bOpen;
   xmlNsPtr  ns;
   xmlDocPtr doc;
   
   unsigned char *convert(char *, char *);
   
protected:
   char *name;
   char *manufacturer;
   char *model;
   char *interface;
   char *licence;
   char *copyright;
   char *createwho;
   char *modwho;
   
   tm	 createwhen;
   tm	 modwhen;
   
   int   num_prog_keys;
   
   bool bTouchscreen;
   int  disp_type;
   int  disp_x;
   int  disp_y;
   int  res_x;
   int  res_y;
   
   //void ParseButtonMap(xmlNodePtr node, CButtonTable&);
   //void ParseButton(xmlNodePtr node, CSmartButton&);
   unsigned int CharToKey(char *c);
   char KeyToChar(unsigned int);
   unsigned int ModiferValue(xmlChar *val);
   int ValueModifier(unsigned int, xmlChar *val);
   //xmlNodePtr FindNode(int, CButtonTable& k);
   
public:
   ButtonTableParser();
   ~ButtonTableParser();
   int  New();
   int  Open(const char *fname, bhpos::widget::ButtonTable&);
   void Close();
   //int  Save(const char *fname, CKeyMap&);
   int  SetParameter(unsigned int, void *);
   int  GetParameter(unsigned int, void *);
   int  AddButtonNode(bhpos::widget::SmartButton& k);
   int  DeleteButtonNode(bhpos::widget::SmartButton& k);
   int  ModifyButtonNode(bhpos::widget::SmartButton& k);
   int  ModifyProps(unsigned int, void *);
   void Validate(char *);
};

/* }@  */

}

/* }@  */

}

#endif   // BUTTONTABLE_H
