/*
bhselbox.cpp
Copyright (C) 2005 Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/

#include "config.h"
#include <gtkmm/radiobutton.h>
#include "bhintl.h"
#include "bhselbox.h"

namespace bhpos{

namespace widget{

bhselbox::bhselbox(char *title, char *pm, char *message, BhSelList *list) 
{
   int num=list->num_items-1;
   BhSelItem *i=list->items;
   
   icon = manage(new class Gtk::Image(pm));
   label = manage(new class Gtk::Label(message));
   Gtk::VBox *vbox = Gtk::manage(new class Gtk::VBox(false, 0));
   yes=Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-yes")));
   no=Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-no")));
   Gtk::HBox *hbox = manage(new class Gtk::HBox(false, 0));
   Gtk::HBox *hbox2 = manage(new class Gtk::HBox(false, 0));
   
   //icon->set_size(24, 24);
   icon->set_alignment(0.5, 0.5);
   icon->set_padding(10, 10);
   label->set_alignment(0.5, 0.5);
   label->set_padding(5, 5);
   vbox->set_border_width(5);
   vbox->pack_start(*icon);
   vbox->pack_start(*label);
   
   hbox->set_border_width(5);
   hbox->pack_start(*vbox);
   
   Gtk::RadioButton::Group radiogrp;
   Gtk::RadioButton *r;
   
   g_print("num:%d", num);
   while(num){
      r = Gtk::manage(new class Gtk::RadioButton(radiogrp, i->label));
      hbox2->pack_start(*r);
      r->show();
      g_print("label%d - %s\n", num, i->label);
      num--;
      i++;
   }
   hbox->pack_start(*hbox2);
   set_border_width(5);
   get_action_area()->property_layout_style().set_value(Gtk::BUTTONBOX_END);
   get_vbox()->set_homogeneous(false);
   get_vbox()->set_spacing(5);
   get_vbox()->pack_start(*hbox);
   set_title(title);
   property_window_position().set_value(Gtk::WIN_POS_CENTER);
   set_resizable(false);
   property_destroy_with_parent().set_value(false);
   set_has_separator(true);
   
   set_modal(true);
   
   yes->show();
   no->show();	
   icon->show();
   label->show();
   hbox->show();
   hbox2->show();
   vbox->show();
   yes->grab_focus();
   show();
   
   yes->signal_clicked().connect(sigc::mem_fun(*this, &bhselbox::on_yes_clicked));
	no->signal_clicked().connect(sigc::mem_fun(*this, &bhselbox::on_no_clicked));
}

void bhselbox::on_yes_clicked()
{
	event_signal.emit(1, 0);
	this->destroy_();
}

void bhselbox::on_no_clicked()
{
	event_signal.emit(0, 0);
	this->destroy_();  
}

}

}
